<template>
    <div>
        <v-row class="justify-center">
            <v-col  md="4" sm="12" class="pa-0"  v-if="modoVista != 3">
                <div class="visor">
                    <div>
                        <div class="pa-2 visor__titulo">
                            <h3>Evidencia Actual</h3>
                            <label class="normal">{{ dataLateral.imagenes.length }} fotos</label>
                        </div>
                        <v-sheet class="pa-2 txtMotivo">
                            <span class="d-flex justify-space-between align-center mb-2">
                                <h4><strong> Motivo de rechazo</strong></h4>
                                <small>30/10/2020</small>
                            </span>
                            <div class="tLeft">Falta mantenimiento y reorganizar los extractores.</div>
                        </v-sheet>
                    </div>
                    <div class="scroll">
                        <div class="visor__lateral">
                            <div v-for="(data, index) in dataLateral.imagenes" :key="index">
                                <img :src="obtenerImgUrl(data.nombreImg, data.formatoImg)" >
                            </div>
                            <div class="comentariosVisor">
                                <strong>Comentario</strong>
                                <small>02/04/2020</small>
                                Los extractores que se presentan están sucios y les falta un correcto mantenimiento.
                                <div class="img__boton img__boton--zoom-arriba"  @click.stop="dialogEvidencia = true">
                                    <img src="@/assets/img/visorFotografias/zoom.svg">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </v-col>
            <v-col md="8" sm="12" class="pa-0">
                <div class="d-flex flex-column visor">
                    <div class="pa-2 visor__titulo">
                        <h3>Nueva evidencia</h3>
                        <template v-if="archivos.length > 0">
                            <div class="avanzar-img">
                                <img src="@/assets/img/icoAtras.svg" @click="avanzarImg(1)" v-bind:class="{'desac': archivoSeleccionado.posicion == 0 || archivos.length == 0}"> 
                                    <label> {{ (archivoSeleccionado.posicion + 1) }} / {{ archivos.length }} </label> 
                                <img src="@/assets/img/icoSiguiente.svg" @click="avanzarImg(2)" v-bind:class="{'desac': archivoSeleccionado.posicion == archivos.length - 1 || archivos.length == 0}">
                            </div>
                            <label> {{ archivos.length }} fotos</label>
                        </template>
                    </div>
                    <div class="visor__img-carousel" v-if="archivos.length > 0">
                        <div class="img__container">
                            <img :src="obtenerImgUrl(archivoSeleccionado.nombreImg, archivoSeleccionado.formatoImg)">
                            <div class="img__boton img__boton--zoom"  @click.stop="dialogEvidencia = true">
                                <img src="@/assets/img/visorFotografias/zoom.svg">
                            </div>
                            <div class="img__boton img__boton--eliminar" @click="eliminarImg(archivoSeleccionado.posicion)" v-if="modoVista == 1">
                                <img src="@/assets/img/icoEliminarBlanco.svg">
                            </div>
                        </div>
                    </div>
                    <div 
                        class="pa-4 ma-4 dragdrop" 
                        v-bind:class="{'dragdrop__agregar-archivo': entraDrag, 'flex-grow-1': archivos.length == 0}" 
                        @drop.prevent="agregarImg($event, 1)" 
                        @dragover.prevent="entraDrag = true" 
                        @dragleave.prevent="entraDrag = false"
                        v-if="modoVista == 1"
                    >
                        <input type="file" multiple value="Elegir archivos" @change="agregarImg($event, 2)"/>
                        <img src="@/assets/img/visorFotografias/imagenAgregar.svg">
                        <template>
                            <label class="text-center">Da clic aquí o arrastra archivos desde tu computadora<br>para agregar evidencias</label>
                        </template>
                    </div>
                    <div class="pa-3 pb-0 visores__comentarios">
                        <template v-if="modoVista == 1">
                            <div class="d-flex align-center justify-space-between">
                                Comentario
                                <small class="red--text">300 caracteres</small>
                            </div>
                            <v-text-field maxlength="50" outlined solo background-color="white" placeholder="Ingrese un comentario..."></v-text-field>
                        </template>
                        <div class="mb-4 px-2 comentariosVisor" v-if="modoVista != 1">
                            <h4><strong>Comentario</strong></h4>
                            <small class="mb-1">02/04/2020</small>
                            <label>Los extractores estan sucios y les falta un correcto mantenimiento</label>
                        </div>
                    </div>
                </div>
            </v-col>
        </v-row>

         <!--Modal Nueva evidencia Hallazgos-->
        <v-dialog v-model="dialogEvidencia" max-width="600" >
            <v-card>
                <div class="btnCerrarModal"  @click="dialogEvidencia = false"><div>X</div></div>
                <v-card-title class="headline">
                    <div class="titModal">Nueva evidencia</div>
                </v-card-title>
                
                <div  class="contModal tCenter">
                    <img class="icoVisor" :src="obtenerImgUrl(archivoSeleccionado.nombreImg, archivoSeleccionado.formatoImg)">
                    <div class="pa-2 visor__titulo justify-center">
                        <div class="avanzar-img">
                            <img src="@/assets/img/icoAtras.svg" @click="avanzarImg(1)" v-bind:class="{'desac': archivoSeleccionado.posicion == 0 || archivos.length == 0}"> 
                                <label> {{ (archivoSeleccionado.posicion + 1) }} / {{ archivos.length }} </label> 
                            <img src="@/assets/img/icoSiguiente.svg" @click="avanzarImg(2)" v-bind:class="{'desac': archivoSeleccionado.posicion == archivos.length - 1 || archivos.length == 0}">
                        </div>
                    </div>
                    <div class="comentariosVisor">
                        <strong>Comentario</strong>
                        <small>02/06/2020</small>
                        Los extractores que se presentan están sucios y les falta un correcto mantenimiento.
                    </div>
                </div>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
export default {
    name: 'VisorFotografia',
    data: () => ({
        archivos: [],
        comentario: '',
        entraDrag: false,
        archivoSeleccionado: {
            posicion: 0,
            nombreImg: 'elektra5',
            formatoImg: 'jpeg'
        },
        dialogEvidencia: false,
    }),
    props: ['titulo', 'dataLateral', 'modoVista'],
    methods: {

        avanzarImg(accion){
            if(accion == 1){
                this.archivoSeleccionado.posicion--;
            }else{
                this.archivoSeleccionado.posicion++;
            }

            //Solo para representar el cambio de imagen
            this.archivoSeleccionado.nombreImg = this.archivoSeleccionado.nombreImg == 'elektra5' ? 'elektra6' : 'elektra5';
        },

        agregarImg(event, tipo){ 
            let files = (tipo == 1 ? event.dataTransfer.files : event.target.files);

            for(let key of Object.keys(files)){
                this.archivos = [...this.archivos, files[key]];
            }
        },

        eliminarImg(posicion){
            this.archivos.splice(posicion, 1);
            this.archivoSeleccionado.posicion = posicion > 0 ? posicion - 1 : 0;
            this.archivoSeleccionado.nombreImg = this.archivoSeleccionado.nombreImg == 'elektra5' ? 'elektra6' : 'elektra5';
        },

        obtenerImgUrl(imgNombre, imgFormato) {
            return require('@/assets/img/visorFotografias/' + imgNombre + '.' + imgFormato)
        }
    },
    created: function() {
        if(+this.modoVista == 2 || +this.modoVista == 3){
            this.comentario = 'Los extractores que se presentan estan sucios y les falta un correcto mantenimiento';
            this.archivos = [
                'elektra1.jpg',
                'elektra2.jpg',
                'elektra3.jpg',
                'elektra4.jpg',
            ]
        }
    }
}
</script>
<style scoped>
    .visor{
        background-color: #ffff;
        height: 100%;
        padding: 10px 3%;
        margin-right: 20px;
    }

    .visor__lateral{
        max-height: 46rem;
        overflow: auto;
    }

    .visor__lateral > img{
        width: 100%;
        height: auto;
        margin: 0px auto 10px auto;
    }

    .visor__titulo{
        background-color: #ffffff;
        border-bottom: 2px solid lightgray;
        margin-bottom: 20px;
        display: flex;
        align-items: center;
        justify-content: space-between;
        font-family: "Avenir_Next_Demi_Bold";
    }

    .visor__img-carousel{
        display: flex;
        justify-content: center;
        align-items: center;
        padding: 0 1rem;        
        position: relative;
    }

    .img__container{
        position: relative;
        width: 100%;
        max-width: 100%;
    }

    .img__container > img{
        display: block;
        width: 100%;
        height: auto;
    }

    .img__boton{
        position: absolute;
        opacity: 1;
        height: 1.7rem;
        width: 1.7rem;
        margin: 1rem;
        border-radius: 50%;
        display: flex;
        align-items: center;
        justify-content: center;
        cursor: pointer;
    }

    .img__boton > img{
        height: 1rem;
        width: 1rem;
    }

    .img__boton--zoom{
        bottom: 0;
        right: 0;
        background-color: var(--main-bg-color);  
    }

    .img__boton--zoom-arriba{
        top: -15px;
        right: -10px;
        background-color: var(--main-bg-color);  
    }

    .img__boton--eliminar{
        top: -.7rem;
        right: -.7rem;
        margin: 0;
        background-color: #575757; 
    }

    .dragdrop{
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        /*border: 2px dashed var(--main-bg-color);*/
        border: 2px dashed #c2c2c2;
        border-radius: 1rem;
        position: relative;
        max-height: 46rem;
    }

    .dragdrop__agregar-archivo{
       border: 2px dashed var(--main-color);
    }

    .dragdrop > input[type="file"]{
        width: 100%;
        height: 100%;
        position: absolute;
        opacity: 0;
        cursor: pointer;
    }

    .dragdrop > img{
        height: 7rem;
        margin-bottom: 1rem;
    }

    .dragdrop > label{
        font-size: 1rem;
    }

    /*---------------------------*/ 

    .visores{
        display: flex;
        align-items: center;
        align-items: stretch;
    }

    .visores__visor{
        display: flex;
        text-align: center;
        justify-content: center;
        flex-direction: column;
    }

    .visores__img{
        width: 99%;
        margin-right: 1%;
        margin-top: 6px;
        display: flex;
        flex-direction: column;
        margin-bottom: 10px;
    }

    .visores__img-eliminar{
        position: absolute;
        display: flex;
        align-items: center;
        cursor: pointer;
        top: 5px;
        right: 0;
        margin-right: 1rem;
    }

    .visores__img-eliminar > img{
        height: 0.9rem;
        margin-right: 3px;
        cursor: pointer;
    }

    .visores__img-eliminar > label{
        font-size: 13px;   
        text-decoration: underline;
        cursor: pointer;
    }

    .visores__img > span{
        background-color: #f2f2f2;
        padding: 5px 0px;
        height: 24px;
        font-family: "AvenirNextLTPro-Medium";
        position: relative;
    }

    .visores__img > div{
        border-style: solid;
        border-color: #cccccc;
        border-width: 0px 1px 1px 1px;
        padding: 10px 10px;
        min-height: 280px;
        max-height: 280px;
        overflow-y: auto;
        overflow-x: auto;
        background-color: #ffff;
    }

    .visores__img > div > img{
        width: 90%;
    }

    .visores__comentarios{
        display: flex;
        flex-direction: column;
    }

    .avanzar-img > img{
        cursor: pointer;
    }

    .btnArchivos{
        position: relative;
        display: flex;
        flex-direction: column;
    }

    .btnArchivos > input[type="file"]{
        opacity: 0;
        z-index: 1;
        cursor: pointer;
        height: 100%;
    }

    .btnArchivos > label{
        position: absolute;
    }

    .comentariosVisor{
        font-size: 14px;
        text-align: left;
        margin: 10px 0px;
        display: flex !important;
        flex-direction: column;
        position: relative;
    }

    .comentariosVisor small{
        color:#b8b8b8;
        font-size: 12px;
        margin-bottom: 1rem;
    }

    .icoVisor{
        width: 100%;
    }

    .txtMotivo{
        background-color: #fac598; 
        margin-bottom: 20px;
    }

    .visor__lateral > div img{ 
        width: 100%;
    }

    @media screen and (max-width: 960px) {
        .visor__lateral{
            display: flex;
            flex-direction: row-reverse;
            min-width: 600px;
        }

        .visor__lateral > div { 
            padding: 0px 10px 5px 0px;
        }

        .visor__lateral > div img{ 
            width: 100%;
        }
    }
</style>